﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using WebApplication1.Models;

namespace WebApplication1.Controllers
{
    public class NikDemoController : Controller
    {
        static Random rnd = new Random();
        private bool IsPrime(int num)
        {
            if (num < 2) return false;
            double lim = Math.Sqrt(num);
            for (int i=2; i<=lim; i++)
            {
                if (num % i == 0) return false;
            }
            return true;
        }

        // GET: NikDemo/Numbers
        public ActionResult Numbers()
        {
            NumberItem[] myArray = new NumberItem[100];
            for (int i=0; i< myArray.Length; i++)
            {
                int randomNumber = rnd.Next(100, 1000);
                myArray[i]=new NumberItem()
                {
                    Value = randomNumber, IsPrime = IsPrime(randomNumber)                    
                };
            }
            int maxValue = myArray.Max(x => x.Value);
            myArray.Where(x => x.Value == maxValue).ToList().ForEach(x => x.IsMax = true);
            return View("Numbers", myArray);
        }

        // GET: NikDemo/Miles
        public ActionResult Miles()
        {
            return View("MilesInput");
        }

        // POST: NikDemo/Miles
        [HttpPost]
        public ActionResult Miles(MilesInput input /* double numKm */)
        {
            /*
            MilesResult mr = new MilesResult() {
                OriginalInput = numKm, 
                NumYards = numKm * 1000 * 1.09361, 
                NumMiles = numKm * 0.621371
            };
            */
            // IActionValueBinder: FormUri, FromBody, ModelBinder, Converter, ValueProvider ...
            // NO AUTOMATIC ERROR HANDLING

            if (!Request.Form.Keys.Contains(nameof(MilesInput.NumKm))) // case sensitive?
            {
                TempData["myWarning"] = "MISSING DATA";
                return this.RedirectToAction(nameof(Miles));
            }
            if (input.NumKm < 0)
            {
                TempData["myWarning"] = "INVALID DATA";
                return this.RedirectToAction(nameof(Miles));
            }

            MilesResult mr = new MilesResult()
            {
                OriginalInput = input.NumKm,
                NumYards = input.NumKm * 1000 * 1.09361,
                NumMiles = input.NumKm * 0.621371
            };
            return View("MilesResult", mr);
        }
    }
}